//+------------------------------------------------------------------+
//|                                                                  |
//|                       |
//|                                                                  |
//+-------------------  --------------------+-----------------------

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4


extern int MagicNumber = 0;
extern bool SignalMail = False;
extern bool EachTickMode = False;
extern double Lots = 0.5;
extern int Slippage = 0;
extern bool UseStopLoss = False;
extern int StopLoss = 30;
extern bool UseTakeProfit = False;
extern int TakeProfit = 60;
extern bool UseTrailingStop = False;
extern int TrailingStop = 30;


int BarCount;
int Current;
bool TickCheck = False;



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;



   if (EachTickMode && Bars != BarCount) TickCheck = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+

double Var1 = iMA(NULL, 0, 20, 0, MODE_SMA, PRICE_CLOSE, 1);// all shifts parameter are at Bar 1
double Var2 = iRSI(NULL, 0, 25, PRICE_CLOSE, 1);
double Var3 = iClose(NULL, 0, 1);

double Buy1_1 =  Var3 ;
double Buy1_2 =  Var1 ;
double Buy2_1 =  Var2 ;
double Buy2_2 = 70;
double Sell1_1 =  Var3 ;
double Sell1_2 =  Var1 ;
double Sell2_1 =  Var2 ;
double Sell2_2 = 70;
double CloseBuy1_1 =  Var3 ;
double CloseBuy1_2 =  Var1 ;
double CloseSell1_1 =  Var3 ;
double CloseSell1_2 =  Var1 ;



   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool Is_New_Bar() // func to check for new bar arrival
{
  if(last_Time != Time[0]) {last_Time = Time[0]; return(true); }
}
   bool IsTrade = False;


   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         IsTrade = True;
         if(OrderType() == OP_BUY) {
            //Close

            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Buy)                                           |
            //+------------------------------------------------------------------+

                     if (CloseBuy1_1 < CloseBuy1_2) Order = SIGNAL_CLOSEBUY;


            
            //+------------------------------------------------------------------+
            //| Signal Begin(Exit Sell)                                          |
            //+------------------------------------------------------------------+
            
 

                     if (CloseSell1_1 > CloseSell1_2) Order = SIGNAL_CLOSESELL;


            
   

   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+


if( Is_New_Bar() ) // only checking once at close of bar
{
  Alert (" Closing of previous ", TimeToStr(Time[1])," Bar ! Checking if Order criteria is met ");


   if (Buy1_1 > Buy1_2 && Buy2_1 > Buy2_2) Order = SIGNAL_BUY;

   if (Sell1_1 < Sell1_2 && Sell2_1 < Sell2_2) Order = SIGNAL_SELL;


   
   

   if (!EachTickMode) BarCount = Bars;

   return(0);
}
//+------------------------------------------------------------------+